<?php
/*
Plugin Name: افزونه درگاه پرداخت پی‌استار برای Hostbill 
Plugin URI: https://paystar.ir
Description: افزونه درگاه پرداخت پی‌استار برای Hostbill - طراح و برنامه نویس : <a target="_blank" href="https://paystar.ir">شایان کیانی</a>
Version: 1.0
Author: Shayan Kiyani
Author URI: https://paystar.ir
Copyright: 2016-2019 paystar.ir
*/

class paystar extends PaymentModule 
{	
	protected $modname;

    protected $description = 'ماژول توسط <a href="https://paystar.ir">شایان کیانی</a> طراحی شده است . <br>خواهشمندیم کپی نفرمایید .';

	protected $version = '1.0';
	
    protected $supportedCurrencies = array('IRR');
	
	protected $configuration = array(
		'pin' => array(
			'value' 	  => '',
			'type'		  => 'input',
			'description' => 'شناسه درگاه خود را وارد نمایید .'
		),
		'success_message' => array(
			'value'       => 'پرداخت با موفقیت انجام شد.',
			'type'        => 'input',
			'description' => 'پیام درصورت موفقیت آمیز بودن تراکنش'
		),
	);

	public function __construct($ws_config=array())
	{
		parent::__construct();
		
		require(dirname(__FILE__) . '/../../../paystarconfig.php');
		
		$this->ws_config = $ws_config;
		$this->modname = $this->ws_config['name'];
	}
	
    public function drawForm() 
	{
		if(!empty($_POST['shayanbank']))
		{
			try 
			{
				$err = false;
				
				$amount = str_replace('.', '', $this->amount);
				$callback = $this->callback_url . '&invoiceid=' . $this->invoice_id . '&amount=' . $amount . '&am=' . $this->amount;

				$description = "شماره سفارش خریدار : {$this->invoice_id}";
				$description .= "\nایمیل خریدار : {$this->client['email']}";
				$description .= !empty($this->client['phonenumber']) ? "\nتلفن همراه خریدار : {$this->client['phonenumber']}" : '';

				$f = array(
					'amount' => $amount,
					'pin' => trim($this->configuration['pin']['value']),
					'callback' => $callback,
					'bank' => $_POST['shayanbank'],
					'description' => $description
				);

				$f_ = '';
				foreach($f as $k=>$v) 
					$f_ .= $k . '=' . urlencode($v) . '&'; 
					
				rtrim($f_, '&');

				$ch = curl_init();
				curl_setopt($ch,CURLOPT_URL, "https://{$this->ws_config['address']}/api/create/");
				curl_setopt($ch,CURLOPT_POST, count($f));
				curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
				curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
				$res = curl_exec($ch);
				curl_close($ch);
				if (!$res) 
					$err = 'اتصال به بانک برقرار نشد .';
				else 
				{
					if(strlen($res) > 5)
					{
						header("Location: https://{$this->ws_config['address']}/paying/{$res}");
						exit;
					}	
					else
						$err = $res;				
				}
			}
			catch (Exception $e) 
			{
				$err = 'اتصال به بانک برقرار نشد .';
			} 		
		}

		$form = '' . PHP_EOL;
		if(!empty($err))
			$form .= '<p><font color="red">' . $err . '</font></p>';
		$form .= '<form name="paystar" action="' . htmlspecialchars($this->gateway) . '" method="POST">';
		$form .= 'بانک : <select name="shayanbank">';
		foreach($this->ws_config['bank'] as $k=>$v)
			$form .= "<option value='{$k}'>{$v}</option>\n";
		$form .= '</select>';
		$form .= '<input class="submit" type="submit" value=" پرداخت " />';
		$form .= '</form>'; 
		return $form;
	}
	

    function callback() 
	{  
		$err = $res = false;
		if(!empty($_POST['transid']))
		{
			try
			{
				$f = array(
					'amount' => $_GET['am'],
					'pin' => trim($this->configuration['pin']['value']),
					'transid' => $_POST['transid'],
				);
				
				$f_ = '';
				foreach($f as $k=>$v) 
					$f_ .= $k . '=' . urlencode($v) . '&'; 
					
				rtrim($f_, '&');

				$ch = curl_init();
				curl_setopt($ch,CURLOPT_URL, "https://{$this->ws_config['address']}/api/verify/");
				curl_setopt($ch,CURLOPT_POST, count($f));
				curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
				curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
				$res = curl_exec($ch);
				curl_close($ch);
			}
			catch(Exception $e) 
			{
				$res = false;
			}
		
			if($res == 1)
			{
				$this->logActivity(array(
					'result' => 'Successfull',
					'output' => $_POST
				));

				$this->addTransaction(array(
					'in' => $_GET['am'],
					'invoice_id' => $_GET['invoiceid'],
					'fee' => 0,
					'transaction_id' => $_POST['transid']
				  
				));
				$this->addInfo($this->configuration['success_message']['value']);
				Utilities::redirect('index.php?/clientarea/invoice/' . $this->invoice_id);				
			}
			else
				$err = true;
		}
		else
			$err = true;
		
		if(!empty($err))
		{
             $this->logActivity(array(
                'result' => 'Failed',
                'output' => $_POST
				
            ));
			Utilities::redirect('index.php?/clientarea/invoice/' . $this->invoice_id);				
		}
    }
}